<?php

namespace MIQID\Elementor\Widget;

use Elementor\Controls_Manager;
use MIQID\Elementor\Core\Widget_MIQID;

class Text_Hide_If extends Widget_MIQID {

	protected function _register_controls() {

		$this->start_controls_section( 'content', [
			'label' => 'Content',
			'tab'   => Controls_Manager::TAB_CONTENT,
		] );

		$this->add_control( 'text', [
			'label' => 'Text',
			'type'  => Controls_Manager::WYSIWYG,
		] );

		$this->add_control( 'miqid', [
			'label'   => 'MiqId',
			'type'    => Controls_Manager::SELECT,
			'groups' => $this->getMIQIDFields(),
		] );

		$this->add_control( 'match', [
			'label'   => 'Match',
			'type'    => Controls_Manager::TEXT,
			'dynamic' => [ 'active' => false ],
		] );

		$this->add_control( 'negate', [
			'label'   => 'Show If',
			'type'    => Controls_Manager::SWITCHER,
			'dynamic' => [ 'active' => false ],
		] );

		$this->end_controls_section();

	}

	protected function render() {
		$settings = $this->get_settings_for_display();
		$text     = $settings['text'];
		$miqid    = $settings['miqid'];
		$negate   = filter_var( $settings['negate'], FILTER_VALIDATE_BOOLEAN, FILTER_NULL_ON_FAILURE ) ?? false;
		$data     = null;
		$icon_str = null;

		if ( ! empty( $miqid ) ) {
			$data = $this->get_miqid_data( $miqid );
		}

		if ( ! empty( $miqid ) && ! empty( $data ) ) {
			$text = $negate && preg_match( '/' . $settings['match'] . '/i', $data ) ? $text
				: ( ! preg_match( '/' . $settings['match'] . '/i', $data ) ? $text : '' );
		}

		?>
        <div class="elementor-widget-container <?= $this->get_name() ?>">
            <div class="elementor-text-editor elementor-clearfix text">
				<?= $text ?>
            </div>
        </div>
		<?php
	}

}